## apache2 2.4.66

=== CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Read README.cmake before using this.

PROJECT(HTTPD C)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

INCLUDE(CheckSymbolExists)
INCLUDE(CheckCSourceCompiles)
INCLUDE("build/build-modules-c.cmake")

FIND_PACKAGE(LibXml2)
FIND_PACKAGE(Lua51)
FIND_PACKAGE(OpenSSL)
FIND_PACKAGE(ZLIB)
FIND_PACKAGE(CURL)
FIND_PACKAGE(PCRE2 COMPONENTS 8BIT)

# Options for support libraries not supported by cmake-bundled FindFOO

# Default to using APR trunk (libapr-2.lib) if it exists in PREFIX/lib;
# otherwise, default to APR 1.x + APR-util 1.x
IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/libapr-2.lib")
  SET(default_apr_libraries "${CMAKE_INSTALL_PREFIX}/lib/libapr-2.lib")
ELSEIF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/libapr-1.lib")
  SET(ldaplib "${CMAKE_INSTALL_PREFIX}/lib/apr_ldap-1.lib")
  IF(NOT EXISTS ${ldaplib})
    SET(ldaplib)
  ENDIF()
  SET(default_apr_libraries ${CMAKE_INSTALL_PREFIX}/lib/libapr-1.lib ${CMAKE_INSTALL_PREFIX}/lib/libaprutil-1.lib ${ldaplib})
ELSE()
  SET(default_apr_libraries)
ENDIF()

# PCRE names its libraries differently for debug vs. release builds.
# We can't query our own CMAKE_BUILD_TYPE at configure time.
# If the debug version exists in PREFIX/lib, default to that one.
IF(PCRE2_FOUND)
  SET(default_pcre_libraries "PCRE2::8BIT")
  SET(default_pcre_cflags "-DHAVE_PCRE2")
ELSEIF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/pcre2-8d.lib")
  SET(default_pcre_libraries ${CMAKE_INSTALL_PREFIX}/lib/pcre2-8d.lib)
  SET(default_pcre_cflags "-DHAVE_PCRE2")
ELSEIF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/pcre2-8.lib")
  SET(default_pcre_libraries ${CMAKE_INSTALL_PREFIX}/lib/pcre2-8.lib)
  SET(default_pcre_cflags "-DHAVE_PCRE2")
ELSEIF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/pcred.lib")
  SET(default_pcre_libraries ${CMAKE_INSTALL_PREFIX}/lib/pcred.lib)
ELSE()
  SET(default_pcre_libraries ${CMAKE_INSTALL_PREFIX}/lib/pcre.lib)
ENDIF()

IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/nghttp2d.lib")
  SET(default_nghttp2_libraries "${CMAKE_INSTALL_PREFIX}/lib/nghttp2d.lib")
ELSE()
  SET(default_nghttp2_libraries "${CMAKE_INSTALL_PREFIX}/lib/nghttp2.lib")
ENDIF()

IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/brotlienc.lib")
  SET(default_brotli_libraries "${CMAKE_INSTALL_PREFIX}/lib/brotlienc.lib" "${CMAKE_INSTALL_PREFIX}/lib/brotlicommon.lib")
ELSE()
  SET(default_brotli_libraries)
ENDIF()

IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/libcurl_imp.lib")
  SET(default_curl_libraries "${CMAKE_INSTALL_PREFIX}/lib/libcurl_imp.lib")
ELSEIF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/libcurl.lib")
  SET(default_curl_libraries "${CMAKE_INSTALL_PREFIX}/lib/libcurl.lib")
ELSE()
  SET(default_curl_libraries)
ENDIF()

IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/jansson.lib")
  SET(default_jansson_libraries "${CMAKE_INSTALL_PREFIX}/lib/jansson.lib")
ELSE()
  SET(default_jansson_libraries)
ENDIF()

SET(APR_INCLUDE_DIR       "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with APR[-Util] include files")
SET(APR_LIBRARIES         ${default_apr_libraries}       CACHE STRING "APR libraries to link with")
SET(NGHTTP2_INCLUDE_DIR   "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with NGHTTP2 include files within nghttp2 subdirectory")
SET(NGHTTP2_LIBRARIES     ${default_nghttp2_libraries}   CACHE STRING "NGHTTP2 libraries to link with")
SET(PCRE_CFLAGS           "${default_pcre_cflags}"       CACHE STRING "PCRE flags for util_pcre.c compilation")
SET(PCRE_INCLUDE_DIR      "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with PCRE include files")
SET(PCRE_LIBRARIES        ${default_pcre_libraries}      CACHE STRING "PCRE libraries to link with")
SET(LIBXML2_ICONV_INCLUDE_DIR     ""                     CACHE STRING "Directory with iconv include files for libxml2")
SET(LIBXML2_ICONV_LIBRARIES       ""                     CACHE STRING "iconv libraries to link with for libxml2")
SET(BROTLI_INCLUDE_DIR    "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with include files for Brotli")
SET(BROTLI_LIBRARIES      ${default_brotli_libraries}    CACHE STRING "Brotli libraries to link with")
SET(CURL_INCLUDE_DIR      "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with include files for cURL")
SET(CURL_LIBRARIES        ${default_curl_libraries}         CACHE STRING "cURL libraries to link with")
SET(JANSSON_INCLUDE_DIR   "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with include files for jansson")
SET(JANSSON_LIBRARIES     "${default_jansson_libraries}" CACHE STRING "Jansson libraries to link with")
# end support library configuration

# Misc. options
OPTION(INSTALL_PDB        "Install .pdb files (if generated)"  ON)
OPTION(INSTALL_MANUAL     "Install manual"                     ON)

SET(ENABLE_MODULES        "O"                            CACHE STRING "Minimum module enablement (e.g., \"i\" to build all but those without prerequisites)")
SET(WITH_MODULES          ""                             CACHE STRING "comma-separated paths to single-file modules to statically link into the server")
SET(EXTRA_INCLUDES        ""                             CACHE STRING "Extra include directories")
SET(EXTRA_LIBS            ""                             CACHE STRING "Extra libraries")
SET(EXTRA_COMPILE_FLAGS   ""                             CACHE STRING "Extra compile flags")

IF(NOT EXISTS "${APR_INCLUDE_DIR}/apr.h")
  MESSAGE(FATAL_ERROR "APR include directory ${APR_INCLUDE_DIR} is not correct.")
ENDIF()
FOREACH(onelib ${APR_LIBRARIES})
  IF(NOT EXISTS ${onelib})
    MESSAGE(FATAL_ERROR "APR library ${onelib} was not found.")
  ENDIF()
ENDFOREACH()

MACRO(DEFINE_WITH_BLANKS output_definition input_symbol input_value)
  IF(MSVC_IDE OR ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION} VERSION_GREATER 2.8.11)
    SET(${output_definition} "-D${input_symbol}=\"${input_value}\"")
  ELSE()
    # command-line tool + older cmake, where extra quotes must be added and
    # escaped to survive
    SET(${output_definition} "-D${input_symbol}=\"\\\"${input_value}\\\"\"")
  ENDIF()
ENDMACRO()

MACRO(GET_MOD_ENABLE_RANK macro_modname macro_mod_enable_val macro_output_rank)
  IF(${macro_mod_enable_val} STREQUAL "O")
    SET(${macro_output_rank} 0)
  ELSEIF(${macro_mod_enable_val} STREQUAL "i")
    SET(${macro_output_rank} 1)
  ELSEIF(${macro_mod_enable_val} STREQUAL "I")
    SET(${macro_output_rank} 2)
  ELSEIF(${macro_mod_enable_val} STREQUAL "a")
    SET(${macro_output_rank} 3)
  ELSEIF(${macro_mod_enable_val} STREQUAL "A")
    SET(${macro_output_rank} 4)
  ELSE()
    MESSAGE(FATAL_ERROR "Unexpected enablement value \"${macro_mod_enable_val}\" for ${macro_modname}")
  ENDIF()
ENDMACRO()

GET_MOD_ENABLE_RANK("ENABLE_MODULES setting" ${ENABLE_MODULES} enable_modules_rank)

# Figure out what APR/APU features are available
#
# CHECK_APR_FEATURE checks for features defined to 1 or 0 in apr.h or apu.h
# The symbol representing the feature will be set to TRUE or FALSE for 
# compatibility with the feature tests set by FindFooPackage.
#
# (unclear why CHECK_SYMBOL_EXISTS is needed, but I was getting "found" for anything 
# not defined to either 1 or 0)

MACRO(CHECK_APR_FEATURE which_define)
  SET(CMAKE_REQUIRED_INCLUDES "${APR_INCLUDE_DIR}")
  CHECK_SYMBOL_EXISTS(${which_define} "apr.h;apu.h" tmp_${which_define})
  IF(${tmp_${which_define}})
    CHECK_C_SOURCE_COMPILES("#include \"${APR_INCLUDE_DIR}/apr.h\"
      #include \"${APR_INCLUDE_DIR}/apu.h\"
      int main() {
      #ifndef ${which_define}
      #error gobble
      #endif
      #if !${which_define}
      #error gobble
      #endif
      return 1;}" ${which_define})
  ELSE()
    SET(${which_define})
  ENDIF()
  IF(${${which_define}})
    SET(${which_define} TRUE)
  ELSE()
    SET(${which_define} FALSE)
  ENDIF()
ENDMACRO()

CHECK_APR_FEATURE(APR_HAS_XLATE)
CHECK_APR_FEATURE(APU_HAVE_CRYPTO)

# APR_HAS_LDAP is defined in apr_ldap.h, which exists only in apr 1.x, so use
# special code instead of CHECK_APR_FEATURE()
# As with CHECK_APR_FEATURE(), convert to a TRUE/FALSE result.
CHECK_C_SOURCE_COMPILES("#include \"${APR_INCLUDE_DIR}/apr.h\"
#include \"${APR_INCLUDE_DIR}/apr_ldap.h\"
int main() {
#if !APR_HAS_LDAP
#error gobble
#endif
return 1;}" APR_HAS_LDAP)
IF(${APR_HAS_LDAP})
  SET(APR_HAS_LDAP TRUE)
ELSE()
  SET(APR_HAS_LDAP FALSE)
ENDIF()

# See if nghttp2 exists in a configured or defaulted location
SET(NGHTTP2_FOUND TRUE)
IF(EXISTS "${NGHTTP2_INCLUDE_DIR}/nghttp2/nghttp2.h")
  FOREACH(onelib ${NGHTTP2_LIBRARIES})
    IF(NOT EXISTS ${onelib})
      SET(NGHTTP2_FOUND FALSE)
    ENDIF()
  ENDFOREACH()
ELSE()
  SET(NGHTTP2_FOUND FALSE)
ENDIF()

# See if we have Brotli
SET(BROTLI_FOUND TRUE)
IF(EXISTS "${BROTLI_INCLUDE_DIR}/brotli/encode.h")
  FOREACH(onelib ${BROTLI_LIBRARIES})
    IF(NOT EXISTS ${onelib})
      SET(BROTLI_FOUND FALSE)
    ENDIF()
  ENDFOREACH()
ELSE()
  SET(BROTLI_FOUND FALSE)
ENDIF()

# See if we have Jansson
SET(JANSSON_FOUND TRUE)
IF(EXISTS "${JANSSON_INCLUDE_DIR}/jansson.h")
  FOREACH(onelib ${JANSSON_LIBRARIES})
    IF(NOT EXISTS ${onelib})
      SET(JANSSON_FOUND FALSE)
    ENDIF()
  ENDFOREACH()
ELSE()
  SET(JANSSON_FOUND FALSE)
ENDIF()


MESSAGE(STATUS "")
MESSAGE(STATUS "Summary of feature detection:")
MESSAGE(STATUS "")
MESSAGE(STATUS "LIBXML2_FOUND ............ : ${LIBXML2_FOUND}")
MESSAGE(STATUS "LUA51_FOUND .............. : ${LUA51_FOUND}")
MESSAGE(STATUS "NGHTTP2_FOUND ............ : ${NGHTTP2_FOUND}")
MESSAGE(STATUS "OPENSSL_FOUND ............ : ${OPENSSL_FOUND}")
MESSAGE(STATUS "ZLIB_FOUND ............... : ${ZLIB_FOUND}")
MESSAGE(STATUS "BROTLI_FOUND ............. : ${BROTLI_FOUND}")
MESSAGE(STATUS "CURL_FOUND ............... : ${CURL_FOUND}")
MESSAGE(STATUS "JANSSON_FOUND ............ : ${JANSSON_FOUND}")
MESSAGE(STATUS "APR_HAS_LDAP ............. : ${APR_HAS_LDAP}")
MESSAGE(STATUS "APR_HAS_XLATE ............ : ${APR_HAS_XLATE}")
MESSAGE(STATUS "APU_HAVE_CRYPTO .......... : ${APU_HAVE_CRYPTO}")
MESSAGE(STATUS "")

# Options for each available module
#   "A" ("A"ctive) means installed and active in default .conf, fail if can't be built
#   "I" ("I"nactive) means installed and inactive (LoadModule commented out) in default .conf, fail if can't be built
#   "O" ("O"mit) means not installed, no LoadModule
#   "a" - like "A", but ignore with a warning if any prereqs aren't available
#   "i" - like "I", but ignore with a warning if any prereqs aren't available

# Current heuristic for default enablement:
#
#   Module requires a prereq and           -> O
#   finding/usingprereq isn't implemented
#   yet
#
#   Module is included by default in       -> a if it has prereqs, A otherwise
#   autoconf-based build 
#
#   Module is included in                  -> i if it has prereqs, I otherwise
#   --enable-modules=most 
#
#   Otherwise                              -> O
#
SET(MODULE_LIST
  "modules/aaa/mod_access_compat+A+mod_access compatibility"
  "modules/aaa/mod_allowmethods+I+restrict allowed HTTP methods"
  "modules/aaa/mod_auth_basic+A+basic authentication"
  "modules/aaa/mod_auth_digest+I+RFC2617 Digest authentication"
  "modules/aaa/mod_auth_form+I+form authentication"
  "modules/aaa/mod_authn_anon+I+anonymous user authentication control"
  "modules/aaa/mod_authn_core+A+core authentication module"
  "modules/aaa/mod_authn_dbd+I+SQL-based authentication control"

=== debian/changelog ===
apache2 (2.4.66-6) unstable; urgency=high

  * Fix upstream mismerge of HTTP2 module leading to SEGV
    (Closes: #1126177)
  * Split testsuite avoiding timeout (Closes: #1126571)

 -- Bastien Roucariès <rouca@debian.org>  Sun, 01 Feb 2026 13:44:20 +0100

apache2 (2.4.66-5) unstable; urgency=medium

  * Upload to sid
  * Add charset for autoindex (Closes: #1125778).
  * Fix zombie process due to FastCGI (Closes: #1125713)

 -- Bastien Roucariès <rouca@debian.org>  Wed, 21 Jan 2026 17:44:52 +0100

apache2 (2.4.66-4) experimental; urgency=medium

  * Readd forgotten suexec-custom.patch patch

 -- Bastien Roucariès <rouca@debian.org>  Sun, 18 Jan 2026 02:27:34 +0100

apache2 (2.4.66-3) experimental; urgency=medium

  [ Helmut Grohne ]
  * Add a new cross build patch (Closes: #1122137)

  [ Bastien Roucariès ]
  * Fix apache2-bin: regular seg faults in mod_http2
    (Closes: #1125368)
  * Emit per default XHTML for autoindex (Closes: #1072804)
  * Add a list-vhosts command (Closes: #1054562)

 -- Bastien Roucariès <rouca@debian.org>  Sat, 17 Jan 2026 12:54:11 +0100

apache2 (2.4.66-2) unstable; urgency=medium

  * Update test framework
  * Parallelize tests when more than 3 CPUs are available

 -- Yadd <yadd@debian.org>  Fri, 05 Dec 2025 18:48:30 +0100

apache2 (2.4.66-1) unstable; urgency=medium

  [ Laurent Bigonville ]
  * Enable systemd module (Closes: #860087).
  * debian/apache2ctl: Fix the restart and greceful when using system.
    When apache is not running and restart or greceful is called, apache
    was running in the user cgroup and system was be confused
    (Closes: #927302).
    This will also avoid to leak fd to apache
    (Closes: #713967).

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #913094)
    + Annotate perl build dependency with :any.
    + cross.patch: Use AC_PATH_TOOL to find pkg-config.
    + Generate server/test_char.h ahead of the build

  [ Jason Perrin ]
  * Fix packaging steps undo setting of setuid bit
    (Closes: #900612)

  [ Bastien Roucariès]
  * Harden systemd services. Set ProtectSystem=full
    ProtectHome=read-only, RestrictSUIDSGID=yes.
    This may break read-write CGI script to /home and
    WebDaV or other CGI/php/lua uses.
  * Move /var/run to /run and /var/lock to /run/lock
  * Allow CAP_SYS_CHROOT for chroot
    (Closes: #1091855)
  * Remove apache2 IPC

  [ Moritz Schlarb ]
  * Support Rules-Requires-Root: no (Closes: #1105015)

  [ Yadd ]
  * New upstream version (Closes: #1121926, CVE-2025-55753, CVE-2025-58098,
    CVE-2025-59775, CVE-2025-65082, CVE-2025-66200)

 -- Yadd <yadd@debian.org>  Fri, 05 Dec 2025 06:35:34 +0100

apache2 (2.4.65-3) unstable; urgency=medium

  * Change default LANG in envvars from C to C.UTF-8
    (Closes: #787584)
  * systemd service apache2 is aliased to httpd
    (Closes: #915855)
  * document a2* environment files in man page
    (Closes: #880421)
  * Failing test in its test suite
    (Closes: #1107289, LP: #2112429)
  * Restart on-abnormal instead of on-abort
    (Closes: #1106280)
  * Allow triggers to use maintscript helper to restart apache
    (LP: #2038912)

 -- Bastien Roucariès <rouca@debian.org>  Mon, 11 Aug 2025 19:07:56 +0200

apache2 (2.4.65-2) unstable; urgency=high

  * Fix SSLProtocol has a duplicate "all"
    (Closes: #1109839)
  * Warn about misconfigured load balancer following fix of
    CVE-2025-23048.

 -- Bastien Roucariès <rouca@debian.org>  Tue, 29 Jul 2025 19:52:31 +0200

apache2 (2.4.65-1) unstable; urgency=medium

  * New upstream version 2.4.65 (Closes: CVE-2025-54090)
  * Unfuzz patch

 -- Yadd <yadd@debian.org>  Wed, 23 Jul 2025 16:05:45 +0200

apache2 (2.4.64-2) UNRELEASED; urgency=medium

  * Per RFC 8996 disable by default TLS 1.0 and TLS 1.1
    (Closes: #943415)

 -- Bastien Roucariès <rouca@debian.org>  Thu, 17 Jul 2025 18:03:42 +0200

=== debian/control ===
Source: apache2
Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Uploaders: Stefan Fritsch <sf@debian.org>,
           Arno Töll <arno@debian.org>,
           Ondřej Surý <ondrej@debian.org>,
           Yadd <yadd@debian.org>,
           Bastien Roucariès <rouca@debian.org>
Section: httpd
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-autoreconf,
               dh-sequence-zz-debputy-rrr (>= 0.1.43~),
               dpkg-dev (>= 1.16.1~),
               bison,
               gawk | awk,
               jdupes,
               libapr1-dev,
               libaprutil1-dev,
               libbrotli-dev,
               libcrypt-dev,
               libcurl4-openssl-dev | libcurl4-dev,
               libjansson-dev,
               liblua5.4-dev,
               libnghttp2-dev,
               libpcre2-dev,
               libssl-dev,
               libsystemd-dev [linux-any],
               libxml2-dev,
               lsb-release,
               perl:any,
               zlib1g-dev
Build-Conflicts: autoconf2.13
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/apache-team/apache2
Vcs-Git: https://salsa.debian.org/apache-team/apache2.git
Homepage: https://httpd.apache.org/
Rules-Requires-Root: no

Package: apache2
Architecture: any
Depends: apache2-bin (= ${binary:Version}),
         apache2-data (= ${source:Version}),
         apache2-utils (= ${binary:Version}),
         media-types,
         procps [!hurd-i386],
         ${misc:Depends},
         ${perl:Depends}
Recommends: ssl-cert
Suggests: apache2-doc,
          apache2-suexec-pristine | apache2-suexec-custom,
          ufw,
          www-browser
Pre-Depends: ${misc:Pre-Depends}
Provides: httpd, httpd-cgi
Description: Apache HTTP Server
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 Installing this package results in a full installation, including the
 configuration files, init scripts and support scripts.

Package: apache2-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Apache HTTP Server (common files)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package contains architecture-independent common files such as icons,
 error pages and static index files.

Package: apache2-bin
Architecture: any
Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
Suggests: apache2-doc,
          apache2-suexec-pristine | apache2-suexec-custom,
          www-browser
Breaks: fossil (<< 1:2.24-5~)
Provides: ${apache2:API}
Description: Apache HTTP Server (modules and other binary files)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package contains the binaries only and does not set up a working
 web-server instance. Install the "apache2" package to get a fully working
 instance.

Package: apache2-utils
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
Description: Apache HTTP Server (utility programs for web servers)
 Provides some add-on programs useful for any web server.  These include:
  - ab (Apache benchmark tool)
  - fcgistarter (Start a FastCGI program)
  - logresolve (Resolve IP addresses to hostnames in logfiles)
  - htpasswd (Manipulate basic authentication files)
  - htdigest (Manipulate digest authentication files)
  - htdbm (Manipulate basic authentication files in DBM format, using APR)
  - htcacheclean (Clean up the disk cache)
  - rotatelogs (Periodically stop writing to a logfile and open a new one)
  - split-logfile (Split a single log including multiple vhosts)
  - checkgid (Checks whether the caller can setgid to the specified group)
  - check_forensic (Extract mod_log_forensic output from Apache log files)
  - httxt2dbm (Generate dbm files for use with RewriteMap)

Package: apache2-suexec-pristine
Architecture: any
Depends: apache2-bin, ${misc:Depends}, ${shlibs:Depends}
Provides: apache2-suexec
Description: Apache HTTP Server standard suexec program for mod_suexec
 Provides the standard suexec helper program for mod_suexec. This version is
 compiled with document root /var/www and userdir suffix public_html. If you
 need different settings, use the package apache2-suexec-custom.

Package: apache2-suexec-custom
Architecture: any
Depends: apache2-bin, ${misc:Depends}, ${shlibs:Depends}
Provides: apache2-suexec
Description: Apache HTTP Server configurable suexec program for mod_suexec
 Provides a customizable version of the suexec helper program for mod_suexec.
 This is not the version from upstream, but can be configured with a
 configuration file.
 .
 If you do not need non-standard document root or userdir settings, it is
 recommended that you use the standard suexec helper program from the
 apache2-suexec-pristine package instead.

Package: apache2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: apache2
Pre-Depends: ${misc:Pre-Depends}
Description: Apache HTTP Server (on-site documentation)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package provides the documentation for the Apache 2 HTTP server. The
 documentation is shipped in HTML format and can be accessed from a local
 running Apache HTTP server instance or by browsing the file system directly.

Package: apache2-dev
Architecture: any
Depends: debhelper (>= 10),
         libapr1-dev,
         libaprutil1-dev,
         libpcre2-dev,
         openssl,
         ${misc:Depends},
         ${perl:Depends}
Provides: dh-apache2, dh-sequence-apache2
Description: Apache HTTP Server (development headers)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package provides development headers and the apxs2 binary for the Apache
 2 HTTP server, useful to develop and link third party additions to the Debian
 Apache HTTP server package.
 .
 It also provides dh_apache2 and dh sequence addons useful to install various
 Debian Apache2 extensions with debhelper. It supports
  - Apache 2 module configurations and shared objects
  - Site configuration files
  - Global configuration files

Package: apache2-ssl-dev
Architecture: any
Multi-Arch: same
Depends: apache2-dev (= ${binary:Version}), libssl-dev, ${misc:Depends}
Description: Apache HTTP Server (mod_ssl development headers)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package provides the development header and the dependencies for
 modules that interact with mod_ssl's internal openssl state.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_BUILD_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
CC_FOR_BUILD ?= cc

LSB_RELEASE := $(shell lsb_release -i -s)
BUILD_DATETIME := $(shell date -u --date="`dpkg-parsechangelog -S Date`" +%FT%T)
MODULE_DIR := /usr/lib/apache2/modules/
API := $(shell perl -ne 'print $$1 if m/define\s+MODULE_MAGIC_NUMBER_MAJOR\s+?(.*)$$/' < include/ap_mmn.h)
OPENSSL := openssl1.1
AP2_CFLAGS = -pipe $(CFLAGS)
AP2_LDFLAGS = -Wl,--as-needed $(LDFLAGS)
AP2_CPPFLAGS = -DPLATFORM='\"$(LSB_RELEASE)\"' -DBUILD_DATETIME='\"$(BUILD_DATETIME)\"' $(CPPFLAGS)
AP2_LTFLAGS = --no-silent

SYSTEMDENABLE:=$(shell LANG=C dpkg-query -W -f='$${Architecture} $${Status}\n' libsystemd-dev:$(DEB_HOST_ARCH) 2>/dev/null | grep -q "install ok installed"; echo $$?)
ifeq "$(SYSTEMDENABLE)" "0"
ENABLE_SYSTEMD_MOD := --enable-systemd
SYSTEMD_MOD := systemd
else
ENABLE_SYSTEMD_MOD := --disable-systemd
SYSTEMD_MOD :=
endif

support/suexec-custom.c: support/suexec.c debian/patches/suexec-custom.patch
	cp support/suexec.c support/suexec-custom.c
	patch -p1 -i debian/patches/suexec-custom.patch

prebuild-checks-stamp:
	ERRS="" ;\
	for a in $$(find debian/config-dir/ -type f) ; do \
		t="$$a.$$$$" ;\
		unexpand < "$$a" > "$$t" ;\
		cmp -s "$$a" "$$t" || ERRS="$$ERRS $$a" ;\
		rm "$$t" ;\
	done ;\
	if [ -n "$$ERRS" ] ; then \
		echo 'ERROR: The following files contain spaces instead of tabs. Run through unexpand!' ;\
		ls -1 $$ERRS ;\
		false ;\
	fi
	MD5=$$(md5sum debian/index.html 2> /dev/null |cut -d' ' -f 1) ; \
	if ! grep -q $$MD5 debian/apache2.postrm ; then \
		echo "ERROR: index.html's md5 is missing in postrm!" ;\
		false ; \
	fi
	touch $@

debian/fixup_conffiles.tgz: \
    debian/config-dir/sites-available/000-default.conf \
    debian/config-dir/sites-available/default-ssl.conf \
    debian/config-dir/conf-available/charset.conf \
    debian/config-dir/conf-available/localized-error-pages.conf \
    debian/config-dir/conf-available/other-vhosts-access-log.conf \
    debian/config-dir/conf-available/security.conf \
    debian/config-dir/mods-available/cern_meta.load \
    debian/config-dir/mods-available/ident.load \
    debian/config-dir/mods-available/imagemap.load
	@# mtime/owner/group/mode are for reproducible build
	tar \
		--mtime=2000-01-01T00:00Z \
		--owner=root:0 \
		--group=root:0 \
		--mode=0644 \
		--transform 's,.*/,,' \
		-c $^ | gzip -n > $@

debian/fixup_conffiles.b64: debian/fixup_conffiles.tgz
	base64 < $< > $@

debian/apache2.preinst: debian/apache2.preinst.in debian/fixup_conffiles.b64 debian/create_preinst
	debian/create_preinst

clean-config-vars-stamp: debian/tmp/usr/share/apache2/build/config_vars.mk debian/clean_config_vars
	# Clean up config_vars.mk so that flags that are only intended for the
	# compilation of apache2 itself are not used by apxs for compiling
	# modules.
	perl ./debian/clean_config_vars '$(AP2_CFLAGS)' '$(AP2_CPPFLAGS)' '$(AP2_LDFLAGS)' '$(CXXFLAGS)'
	touch $@

%: %.in
	sed 's#__SERVER_VERSION__#$(DEB_VERSION_EPOCH_UPSTREAM)#; s#__MODULE_DIR__#$(MODULE_DIR)#; s#__API__#$(API)#; s#__OPENSSL__#$(OPENSSL)#;' $< > $@
	chmod `/usr/bin/stat -c '%a' "$<"` $@

substvars-stamp: debian/rules include/ap_mmn.h
	(grep -s -v apache2:API debian/apache2-bin.substvars; echo "apache2:API=apache2-api-$(API), apache2-api-$(API)-$(OPENSSL)") > debian/apache2-bin.substvars.new
	mv debian/apache2-bin.substvars.new debian/apache2-bin.substvars
	touch $@

suexec-scripts-stamp: $(wildcard debian/debian/apache2-suexec.*.in)
	set -e ; \
	for type in custom pristine ; do \
		for f in postinst preinst prerm links dirs lintian-overrides postrm; do \
			if [ -e debian/apache2-suexec.$$f.in ] ; then \
				perl -pe "s{__TYPE__}{$$type}g" < debian/apache2-suexec.$$f.in > debian/apache2-suexec-$$type.$$f ;\
				chmod `/usr/bin/stat -c '%a' "debian/apache2-suexec.$$f.in"` debian/apache2-suexec-$$type.$$f ;\
			fi ;\
		done ;\
	done
	touch $@

clean build build-arch build-indep binary binary-arch binary-indep: %:
	dh $@ --with=autoreconf

override_dh_auto_configure: configure-stamp
configure-stamp: prebuild-checks-stamp support/suexec-custom.c
	AWK=awk \
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--enable-layout=Debian --enable-so --with-program-name=apache2 \
		--enable-suexec --with-suexec-caller=www-data \
		--with-suexec-bin=/usr/lib/apache2/suexec --with-suexec-docroot=/var/www \
		--with-suexec-userdir=public_html --with-suexec-logfile=/var/log/apache2/suexec.log \
		--with-suexec-uidmin=100 --enable-suexec=shared --enable-log-config=static \
		--with-apr=/usr/bin/apr-1-config --with-apr-util=/usr/bin/apu-1-config \
		--with-pcre=/usr/bin/pcre2-config \
		--enable-pie $(ENABLE_SYSTEMD_MOD) \
		--enable-mpms-shared=all \
		--enable-mods-shared="all brotli cgi ident authnz_fcgi imagemap cern_meta proxy_fdpass proxy_http2 bucketeer case_filter case_filter_in" \
		--enable-mods-static="unixd logio watchdog version $(SYSTEMD_MOD)" \
		CFLAGS="$(AP2_CFLAGS)" CPPFLAGS="$(AP2_CPPFLAGS)" LDFLAGS="$(AP2_LDFLAGS)" \
		LTFLAGS="$(AP2_LTFLAGS)" SHELL=/bin/bash GREP=/bin/grep
# Cross build fails running ./server/gen_test_char. It should be
# built with the build architecture compiler, but the build system is
# incapable of doing so. The mailing list suggests just compiling and
# running that file ahead of the actual build.
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	touch server/gen_test_char.lo
	$(CC_FOR_BUILD) -DCROSS_COMPILE server/gen_test_char.c -o server/gen_test_char
	./server/gen_test_char > server/test_char.h
endif
	touch $@

debian/config-dir/apache2.conf: debian/config-dir/apache2.conf.in
	@# Sanity check that the marker is actually there
	grep -q ___MUTEX___ $<
ifeq "$(DEB_BUILD_ARCH_OS)" "linux"
	@# On linux, we use the default pthread mutex. Comment out
	@# Mutex directive.
	perl -p -e 's,___MUTEX___,#,' < $< > $@
else
	@# On kfreebsd/hurd, pthread mutexes are not robust. There, we need to
	@# use fcntl and set the directory explicitly for multi-instance setups.
	perl -p -i -e 's,___MUTEX___,,' < $< > $@
endif

override_dh_install: clean-config-vars-stamp \
		     substvars-stamp \
		     debian/config-dir/apache2.conf \
		     debian/a2query \
		     debian/debhelper/dh_apache2 \
		     debian/apache2.preinst \
		     suexec-scripts-stamp
	# don't install mod_ssl_openssl.h in apache2-dev
	dh_install -papache2-dev -Xopenssl
	dh_install --remaining-packages

override_dh_missing:
	dh_missing --list-missing

override_dh_installinit:
	dh_installinit --error-handler=true
	# We enable apache-htcacheclean but we don't start it, some
	# custom postinst code will then manually either disable it or
	# start the service
	dh_installinit --name apache-htcacheclean --no-start

override_dh_installsystemd:
	dh_installsystemd -papache2 apache2.service
	dh_installsystemd -papache2 --name=apache2@ apache2@.service
	dh_installsystemd -papache2 --name=apache-htcacheclean apache-htcacheclean.service
	dh_installsystemd -papache2 --name=apache-htcacheclean@ apache-htcacheclean@.service

override_dh_installdocs-indep:
	perl debian/convert_docs debian/apache2-doc/usr/share/doc/apache2-doc/manual
	dh_installdocs -i

override_dh_installdocs-arch:
	dh_installdocs --link-doc=apache2 -papache2
	dh_installdocs --link-doc=apache2-dev -papache2-ssl-dev
	dh_installdocs -a

override_dh_link:
	dh_link
	if test -e debian/apache2-doc/usr/share/doc; then \
		jdupes -rl debian/apache2-doc/usr/share/doc; \
	fi

override_dh_installchangelogs:
	# Do not install changelogs the -data package not to reduce
	# disk space usage.
	dh_installchangelogs -Napache2-data

override_dh_installman:
	mv debian/tmp/usr/share/man/man8/suexec.8 debian/tmp/usr/share/man/man8/suexec-pristine.8
